﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using Infragistics.Win;
using Infragistics.Win.UltraWinTree;

namespace WT_FullRowSelectAndExpansionIndicators
{
    class CustomDrawFilter :IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            var node = drawParams.Element.GetContext() as UltraTreeNode;

            if (node != null)
            {
                if (node.Selected)
                {
                    using (var br = new SolidBrush(drawParams.AppearanceData.BackColor))
                    {
                        drawParams.Graphics.FillRectangle( br, drawParams.Element.Rect);
                    }
                    return true;
                }
            }

            return false;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            var selectableNodeArea = drawParams.Element as TreeNodeUIElement;

            if (selectableNodeArea != null)
                return DrawPhase.BeforeDrawForeground;
            else
                return DrawPhase.None;
        }
    }
}
